

/* Cclient is an application primarily designed to exercise the uSQLcClient
   library for accessing data with the TechFell protocol.

   You must have environment variable set for user, password, server and
   port of the data server.
   Launch with no parameters to get a list of the environment variables
   expected and the actual values.

   Then you may launch Cclient "select * from tst"

   The query must be double quoted

    */

#ifdef WIN32
    #include <winsock2.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include "uSQLcClient.h"

int reccount;

// safelen is used for getting the length of strings passed from unknown
// origins, limits the search.
int safelen(char *s,int max){
int cnt=0;
    while((s[cnt])&&(cnt<=max))cnt++;
    return cnt;
}

int dcallback(void *tag, int argc, char **argv, char **ColName,int fsizes[]){
int i;

    if(reccount==0){
        for(i=0;i<argc;i++)printf("%s;",ColName[i]);
        printf("\n");
    }
    reccount++;
    for(i=0;i<argc;i++)printf("%s;",argv[i]);
    printf("\n");

}

void ecallback(char *err){
	fprintf(stderr,"\n%s\n",err);
}



int main(int argc,char *argv[])
{
uSQLCdb *udb;
int ErrCode;
char passn[64];
#ifdef WIN32
WORD vr;
WSADATA ws;

    vr=MAKEWORD(2,0);
    if(WSAStartup(vr,&ws)){
    	fprintf(stderr,"This program requires winsock 2 DLL or higher\n");
    	return 1;
    }
#endif

    if(argc!=2){
        printf("uSQLUser is set to: %s\n",getenv("uSQLUser"));
        printf("uSQLPass is set to: %s\n",getenv("uSQLPass"));
        printf("uSQLServer is set to %s\n",getenv("uSQLServer"));
        printf("uSQLPort is set to %s\n",getenv("uSQLPort"));
        printf("\nIf these look OK, invoke with somthing like:\n\nCclient \"select * from test where foo='baa'\"\n");
    }
    else{
    	// As a 0 length (null) password is valid, we must intercept the case
    	// where getenv returns (null). As passwords can't have spaces
    	// we check for a spc in the first char
    	sscanf(getenv("uSQLPass"),"%62s",passn);
    	if(*passn=='_')*passn=0;
        udb=uSQLCopen(getenv("uSQLUser"),passn,getenv("uSQLServer"),3002,5000,&ErrCode);
        if(udb){
        	fprintf(stderr,"\nConnected with User Level %i\n",udb->seclevel);
            reccount=0;
            ErrCode=uSQLCexec(udb,argv[1],dcallback,NULL,ecallback);
            fprintf(stderr,"\nError %i : %i Records\n",ErrCode,reccount);
        }
        else fprintf(stderr,"\n\nCclient failed to establish connection code: %i\n\n",ErrCode);

        uSQLCclose(udb);


    }


	// connect to server
	return ErrCode;
}
